diff --git a/modules/STM32F407G-DISC1/board.h b/modules/STM32F407G-DISC1/board.h
index 6caaecb..bf5d76e 100644
--- a/modules/STM32F407G-DISC1/board.h
+++ b/modules/STM32F407G-DISC1/board.h
@@ -215,37 +215,42 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * IO lines assignments.
  */
-#define LINE_BUTTON                 PAL_LINE(GPIOA, 0U)
-#define LINE_LRCK                   PAL_LINE(GPIOA, 4U)
-#define LINE_SPC                    PAL_LINE(GPIOA, 5U)
-#define LINE_SDO                    PAL_LINE(GPIOA, 6U)
-#define LINE_SDI                    PAL_LINE(GPIOA, 7U)
-#define LINE_VBUS_FS                PAL_LINE(GPIOA, 9U)
-#define LINE_OTG_FS_ID              PAL_LINE(GPIOA, 10U)
-#define LINE_OTG_FS_DM              PAL_LINE(GPIOA, 11U)
-#define LINE_OTG_FS_DP              PAL_LINE(GPIOA, 12U)
-#define LINE_SWDIO                  PAL_LINE(GPIOA, 13U)
-#define LINE_SWCLK                  PAL_LINE(GPIOA, 14U)
-#define LINE_SWO                    PAL_LINE(GPIOB, 3U)
-#define LINE_SCL                    PAL_LINE(GPIOB, 6U)
-#define LINE_SDA                    PAL_LINE(GPIOB, 9U)
-#define LINE_CLK_IN                 PAL_LINE(GPIOB, 10U)
-#define LINE_OTG_FS_POWER_ON        PAL_LINE(GPIOC, 0U)
-#define LINE_PDM_OUT                PAL_LINE(GPIOC, 3U)
-#define LINE_MCLK                   PAL_LINE(GPIOC, 7U)
-#define LINE_SCLK                   PAL_LINE(GPIOC, 10U)
-#define LINE_SDIN                   PAL_LINE(GPIOC, 12U)
-#define LINE_RESET                  PAL_LINE(GPIOD, 4U)
-#define LINE_OVER_CURRENT           PAL_LINE(GPIOD, 5U)
-#define LINE_LED4                   PAL_LINE(GPIOD, 12U)
-#define LINE_LED3                   PAL_LINE(GPIOD, 13U)
-#define LINE_LED5                   PAL_LINE(GPIOD, 14U)
-#define LINE_LED6                   PAL_LINE(GPIOD, 15U)
-#define LINE_INT1                   PAL_LINE(GPIOE, 0U)
-#define LINE_INT2                   PAL_LINE(GPIOE, 1U)
-#define LINE_CS_SPI                 PAL_LINE(GPIOE, 3U)
-#define LINE_OSC_IN                 PAL_LINE(GPIOH, 0U)
-#define LINE_OSC_OUT                PAL_LINE(GPIOH, 1U)
+#define LINE_BUTTON                 PAL_LINE(GPIOA, GPIOA_BUTTON)
+#define LINE_LRCK                   PAL_LINE(GPIOA, GPIOA_LRCK)
+#define LINE_SPC                    PAL_LINE(GPIOA, GPIOA_SPC)
+#define LINE_SDO                    PAL_LINE(GPIOA, GPIOA_SDO)
+#define LINE_SDI                    PAL_LINE(GPIOA, GPIOA_SDI)
+#define LINE_VBUS_FS                PAL_LINE(GPIOA, GPIOA_VBUS_FS)
+#define LINE_OTG_FS_ID              PAL_LINE(GPIOA, GPIOA_OTG_FS_ID)
+#define LINE_OTG_FS_DM              PAL_LINE(GPIOA, GPIOA_FS_DM)
+#define LINE_OTG_FS_DP              PAL_LINE(GPIOA, GPIOA_FS_DP)
+#define LINE_SWDIO                  PAL_LINE(GPIOA, GPIOA_SWDIO)
+#define LINE_SWCLK                  PAL_LINE(GPIOA, GPIOA_SWCLK)
+
+#define LINE_SWO                    PAL_LINE(GPIOB, GPIOB_SWO)
+#define LINE_SCL                    PAL_LINE(GPIOB, GPIOA_SCL)
+#define LINE_SDA                    PAL_LINE(GPIOB, GPIOA_SDA)
+#define LINE_CLK_IN                 PAL_LINE(GPIOB, GPIOA_CLK_IN)
+
+#define LINE_OTG_FS_POWER_ON        PAL_LINE(GPIOC, GPIOC_OTG_FS_POWER_ON)
+#define LINE_PDM_OUT                PAL_LINE(GPIOC, GPIOC_PDM_OUT)
+#define LINE_MCLK                   PAL_LINE(GPIOC, GPIOC_MCLK)
+#define LINE_SCLK                   PAL_LINE(GPIOC, GPIOC_SCLK)
+#define LINE_SDIN                   PAL_LINE(GPIOC, GPIOC_SDIN)
+
+#define LINE_RESET                  PAL_LINE(GPIOD, GPIOD_RESET)
+#define LINE_OVER_CURRENT           PAL_LINE(GPIOD, GPIOD_OVER_CURRENT)
+#define LINE_LED4                   PAL_LINE(GPIOD, GPIOD_LED4)
+#define LINE_LED3                   PAL_LINE(GPIOD, GPIOD_LED3)
+#define LINE_LED5                   PAL_LINE(GPIOD, GPIOD_LED5)
+#define LINE_LED6                   PAL_LINE(GPIOD, GPIOD_LED6)
+
+#define LINE_INT1                   PAL_LINE(GPIOE, GPIOE_INT1)
+#define LINE_INT2                   PAL_LINE(GPIOE, GPIOE_INT2)
+#define LINE_CS_SPI                 PAL_LINE(GPIOE, GPIOE_VS_SPI)
+
+#define LINE_OSC_IN                 PAL_LINE(GPIOH, GPIOH_OSC_IN)
+#define LINE_OSC_OUT                PAL_LINE(GPIOH, GPIOE_OSC_OUT)
 
 /*===========================================================================*/
 /* Driver pre-compile time settings.                                         */
diff --git a/modules/STM32F407G-DISC1/module.c b/modules/STM32F407G-DISC1/module.c
index a53ac6e..244b961 100644
--- a/modules/STM32F407G-DISC1/module.c
+++ b/modules/STM32F407G-DISC1/module.c
@@ -62,8 +62,7 @@ SerialConfig moduleHalProgIfConfig = {
  * @brief   Red LED output signal GPIO.
  */
 static apalGpio_t _gpioLedRed = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_LED5,
+  /* line */ LINE_LED5,
 };
 ROMCONST apalControlGpio_t moduleGpioLedRed = {
   /* GPIO */ &_gpioLedRed,
@@ -78,8 +77,7 @@ ROMCONST apalControlGpio_t moduleGpioLedRed = {
  * @brief   Green LED output signal GPIO.
  */
 static apalGpio_t _gpioLedGreen = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_LED4,
+  /* line */ LINE_LED4,
 };
 ROMCONST apalControlGpio_t moduleGpioLedGreen = {
   /* GPIO */ &_gpioLedGreen,
@@ -94,8 +92,7 @@ ROMCONST apalControlGpio_t moduleGpioLedGreen = {
  * @brief   Blue LED output signal GPIO.
  */
 static apalGpio_t _gpioLedBlue = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_LED6,
+  /* line */ LINE_LED6,
 };
 ROMCONST apalControlGpio_t moduleGpioLedBlue = {
   /* GPIO */ &_gpioLedBlue,
@@ -110,8 +107,7 @@ ROMCONST apalControlGpio_t moduleGpioLedBlue = {
  * @brief   Orange LED output signal GPIO.
  */
 static apalGpio_t _gpioLedOrange = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_LED3,
+  /* line */ LINE_LED3,
 };
 ROMCONST apalControlGpio_t moduleGpioLedOrange = {
   /* GPIO */ &_gpioLedOrange,
@@ -126,8 +122,7 @@ ROMCONST apalControlGpio_t moduleGpioLedOrange = {
  * @brief   User button input signal GPIO.
  */
 static apalGpio_t _gpioUserButton = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_BUTTON,
+  /* line */ LINE_BUTTON,
 };
 ROMCONST apalControlGpio_t moduleGpioUserButton = {
   /* GPIO */ &_gpioUserButton,
diff --git a/modules/STM32F407G-DISC1/module.h b/modules/STM32F407G-DISC1/module.h
index 1d1c676..3092959 100644
--- a/modules/STM32F407G-DISC1/module.h
+++ b/modules/STM32F407G-DISC1/module.h
@@ -133,7 +133,7 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(GPIOA_BUTTON)
+#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -148,8 +148,8 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetPadCallback(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, _intCallback, &moduleGpioUserButton.gpio->pad);  \
-  palEnablePadEvent(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));   \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdIntCallback(), &moduleGpioUserButton.gpio->line); \
+  palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                \
 }
 
 /**
diff --git a/periphery-lld/AMiRo-LLD b/periphery-lld/AMiRo-LLD
index 78cc79d..7021191 160000
--- a/periphery-lld/AMiRo-LLD
+++ b/periphery-lld/AMiRo-LLD
@@ -1 +1 @@
-Subproject commit 78cc79d4e470ffbd441c47a8835c138718996c85
+Subproject commit 7021191ecfc8747358c1ea4b331b95ceb8908716
diff --git a/periphery-lld/periphAL.h b/periphery-lld/periphAL.h
index 6e43017..18c9f0f 100644
--- a/periphery-lld/periphAL.h
+++ b/periphery-lld/periphAL.h
@@ -35,7 +35,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   The periphery abstraction layer interface minor version.
  * @note    A higher minor version implies new functionalty, but all old interfaces are still available.
  */
-#define PERIPHAL_VERSION_MINOR    0
+#define PERIPHAL_VERSION_MINOR    1
 
 /*============================================================================*/
 /* DEPENDENCIES                                                               */
@@ -107,8 +107,7 @@ static inline void usleep(apalTime_t us)
  * @brief GPIO driver type.
  */
 struct apalGpio_t {
-  ioportid_t port;
-  iopadid_t pad;
+  ioline_t line;
 } PACKED_VAR;
 
 /**
@@ -124,7 +123,7 @@ static inline apalExitStatus_t apalGpioRead(apalGpio_t* gpio, apalGpioState_t* c
   apalDbgAssert(gpio != NULL);
   apalDbgAssert(val != NULL);
 
-  *val = (palReadPad(gpio->port, gpio->pad) == PAL_HIGH) ? APAL_GPIO_HIGH : APAL_GPIO_LOW;
+  *val = (palReadLine(gpio->line) == PAL_HIGH) ? APAL_GPIO_HIGH : APAL_GPIO_LOW;
   return APAL_STATUS_OK;
 }
 
@@ -140,9 +139,9 @@ static inline apalExitStatus_t apalGpioWrite(apalGpio_t* gpio, const apalGpioSta
 {
   apalDbgAssert(gpio != NULL);
 
-  // palWritePad() is not guaranteed to be atomic, thus the scheduler is locked.
+  // palWriteLine() is not guaranteed to be atomic, thus the scheduler is locked.
   syssts_t sysstatus = chSysGetStatusAndLockX();
-  palWritePad(gpio->port, gpio->pad, (val == APAL_GPIO_HIGH) ? PAL_HIGH : PAL_LOW);
+  palWriteLine(gpio->line, (val == APAL_GPIO_HIGH) ? PAL_HIGH : PAL_LOW);
   chSysRestoreStatusX(sysstatus);
   return APAL_STATUS_OK;
 }
@@ -158,9 +157,9 @@ static inline apalExitStatus_t apalGpioToggle(apalGpio_t* gpio)
 {
   apalDbgAssert(gpio != NULL);
 
-  // palWritePad() is not guaranteed to be atomic, thus the scheduler is locked.
+  // palWriteLine() is not guaranteed to be atomic, thus the scheduler is locked.
   syssts_t sysstatus = chSysGetStatusAndLockX();
-  palWritePad(gpio->port, gpio->pad, (palReadPad(gpio->port, gpio->pad) == PAL_HIGH) ? PAL_LOW : PAL_HIGH);
+  palWriteLine(gpio->line, (palReadLine(gpio->line) == PAL_HIGH) ? PAL_LOW : PAL_HIGH);
   chSysRestoreStatusX(sysstatus);
   return APAL_STATUS_OK;
 }
@@ -179,7 +178,7 @@ static inline apalExitStatus_t apalControlGpioGet(const apalControlGpio_t* const
   apalDbgAssert(cgpio->gpio != NULL);
   apalDbgAssert(val != NULL);
 
-  *val = ((palReadPad(cgpio->gpio->port, cgpio->gpio->pad) == PAL_HIGH) ^ (cgpio->meta.active == APAL_GPIO_ACTIVE_HIGH)) ? APAL_GPIO_OFF : APAL_GPIO_ON;
+  *val = ((palReadLine(cgpio->gpio->line) == PAL_HIGH) ^ (cgpio->meta.active == APAL_GPIO_ACTIVE_HIGH)) ? APAL_GPIO_OFF : APAL_GPIO_ON;
   return APAL_STATUS_OK;
 }
 
@@ -197,9 +196,9 @@ static inline apalExitStatus_t apalControlGpioSet(const apalControlGpio_t* const
   apalDbgAssert(cgpio->gpio != NULL);
   apalDbgAssert(cgpio->meta.direction == APAL_GPIO_DIRECTION_OUTPUT || cgpio->meta.direction == APAL_GPIO_DIRECTION_BIDIRECTIONAL);
 
-  // palWritePad() is not guaranteed to be atomic, thus the scheduler is locked.
+  // palWriteLine() is not guaranteed to be atomic, thus the scheduler is locked.
   syssts_t sysstatus = chSysGetStatusAndLockX();
-  palWritePad(cgpio->gpio->port, cgpio->gpio->pad, ((cgpio->meta.active == APAL_GPIO_ACTIVE_HIGH) ^ (val == APAL_GPIO_ON)) ? PAL_LOW : PAL_HIGH);
+  palWriteLine(cgpio->gpio->line, ((cgpio->meta.active == APAL_GPIO_ACTIVE_HIGH) ^ (val == APAL_GPIO_ON)) ? PAL_LOW : PAL_HIGH);
   chSysRestoreStatusX(sysstatus);
   return APAL_STATUS_OK;
 }
@@ -600,7 +599,7 @@ static inline apalExitStatus_t apalSPITransmit(apalSPIDriver_t* spid, const uint
 }
 
 /**
- * @brief Transmit data to SPI and receive data afterwards without releasing the bus in between
+ * @brief Transmit data to SPI and receive data afterwards without releasing the bus in between.
  *
  * @param   spid        The SPI driver to use.
  * @param   txData      Transmit data buffer.
diff --git a/unittests/periphery-lld/src/ut_alld_DW1000_v1.c b/unittests/periphery-lld/src/ut_alld_DW1000_v1.c
index c5cc995..2600a7a 100755
--- a/unittests/periphery-lld/src/ut_alld_DW1000_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_DW1000_v1.c
@@ -111,13 +111,13 @@ void clear_SPI_chip_select(void){
 void reset_DW1000(void){
 
   // Set the pin as output
-  palSetPadMode(moduleGpioDw1000Reset.gpio->port, moduleGpioDw1000Reset.gpio->pad, APAL_GPIO_DIRECTION_OUTPUT);
+  palSetLineMode(moduleGpioDw1000Reset.gpio->line, APAL_GPIO_DIRECTION_OUTPUT);
 
   //drive the RSTn pin low
   apalGpioWrite(moduleGpioDw1000Reset.gpio, APAL_GPIO_LOW);
 
   //put the pin back to tri-state ... as input
-//  palSetPadMode(moduleGpioDw1000Reset.gpio->port, moduleGpioDw1000Reset.gpio->pad, APAL_GPIO_DIRECTION_INPUT); // TODO:
+//  palSetLineMode(moduleGpioDw1000Reset.gpio->line, APAL_GPIO_DIRECTION_INPUT); // TODO:
 
   aosThdMSleep(2);
 }
diff --git a/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c b/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c
index 204bbe9..e303d45 100644
--- a/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TLC5947_v1.c
@@ -101,7 +101,7 @@ aos_utresult_t utAlldTlc5947Func(BaseSequentialStream *stream, aos_unittest_t *u
     status |= tlc5947_lld_update((TLC5947Driver*)ut->data);
     aosThdMSleep(100);
   }
-  if (status == APAL_STATUS_OK) {
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
     aosUtPassed(stream, &result);
   } else {
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
@@ -121,7 +121,7 @@ aos_utresult_t utAlldTlc5947Func(BaseSequentialStream *stream, aos_unittest_t *u
     aosThdMSleep(100);
   }
   status |= tlc5947_lld_setBlank((TLC5947Driver*)ut->data, TLC5947_LLD_BLANK_ENABLE);
-  if (status == APAL_STATUS_OK) {
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
     aosUtPassed(stream, &result);
   } else {
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
@@ -154,7 +154,7 @@ aos_utresult_t utAlldTlc5947Func(BaseSequentialStream *stream, aos_unittest_t *u
       tlc5947_lld_setBuffer(&buffer, channel, 0);
     }
   }
-  if (status == APAL_STATUS_OK) {
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
     aosUtPassed(stream, &result);
   } else {
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
@@ -179,7 +179,7 @@ aos_utresult_t utAlldTlc5947Func(BaseSequentialStream *stream, aos_unittest_t *u
       tlc5947_lld_setBuffer(&buffer, channel, 0);
     }
   }
-  if (status == APAL_STATUS_OK) {
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
     aosUtPassed(stream, &result);
   } else {
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
